/* asireset.c
*
* The Greenleaf Comm Library
*
* Copyright (C) 1985-1990 Greenleaf Software Inc.  All Rights Reserved.
*
*  int asireset(port)
*  int port;    - Port 0..MAX_PORT
*
* DESCRIPTION
*  This function resets the port's 8250 to it's "pre - asifirst()"
*  condition.  This only applies to the 8250's baud rate registers and modem &
*  line control register (parity, word length etc.).  Executing this
*  function will not disable interrupts in the 8250 if they were
*  running.
*
* SIDE EFFECTS
*  none
*
* RETURNS
*       Value           Meaning
*     -------          --------
*       ASSUCCESS       Successful!
*       ASINVPORT       Requested port is out of range
*       ASNOTSETUP      Requested port not setup with asifirst()
*
* MODIFICATIONS
*  11-02-85     ""
*               Modified for release 2.0
*/
#include <stdio.h>
#include "gf.h"
#include "asiports.h"

int GF_CONV asireset(port)
int port;
{
        struct PORT_TABLE *p;

        if((p=_aschkcnl(port))==NULL)
                return(_aserror);
        _asireset(p->base_8250,p->p_8250[0],p->p_8250[3],p->p_8250[4],
                p->p_8250[1]);
        return(ASSUCCESS);
}

