/* asiwpeek.c
*
* The Greenleaf Comm Library
*
* Copyright (C) 1985-1990 Greenleaf Software Inc.  All Rights Reserved.
*
*  int asiwpeek(port,stat)
*  int port;            - Port 0..MAX_PORT-1
*  char *stat;          - Where to put status if Wide Track buffer
*
* DESCRIPTION
*  this function peeks at the next character and its status in the
*  communications queue without removing them from the queue.
*
* SIDE EFFECTS
*  none.
*
* RETURNS
*
*       Value           Meaning
*       ------          -------
*       0 thru 255      Return value equals character received
*       ASINVPORT       Requested port is out of range
*       ASNOTSETUP      Requested port not setup with asifirst()
*       ASBUFREMPTY     Requested port's buffer is empty
*       ASNOWIDERX      Wide Track receive not enabled for this channel.
*
* MODIFICATIONS
*
*  11-01-85     ""
*               Modified for release 2.0
*/
#include <stdio.h>
#include "gf.h"
#include "asiports.h"

int GF_CONV asiwpeek(port,stat)
int port;
char *stat;
{
        int charstat;
        struct PORT_TABLE *p;

        if((p=_aschkcnl(port))==NULL)
                return(_aserror);
        if(p->chmode_bits.is_rxerror==0)
                return(ASNOWIDERX);
        if(p->chst_bits.rxempty==1)
                return(ASBUFREMPTY);
        charstat=_asipekc(p);
        *stat=(char) ((charstat>>8)&0xff);
        return(charstat&0xff);

}

