/* asixoff.c
*
* The Greenleaf Comm Library
*
* Copyright (C) 1985-1990 Greenleaf Software Inc.  All Rights Reserved.
*
*  int asixoff(port)
*  int port;            - Port 0..MAX_PORT-1
*
* DESCRIPTION
*
*  Disables XON/XOFF type flow control
*
* SIDE EFFECTS
*  none
*
* RETURNS
*
*       Value           Meaning
*     -------          --------
*       ASSUCCESS       Successful
*       ASINVPORT       Requested port is out of range
*       ASNOTSETUP      Requested port not setup with asifirst()
*
* MODIFICATIONS
*
*/
#include <stdio.h>
#include "gf.h"
#include "asiports.h"

int GF_CONV asixoff(port)
int port;
{
        struct PORT_TABLE *p;

        if((p=_aschkcnl(port))==NULL)
                return(_aserror);
        p->chmode_bits.is_xoffmode=0;
        return(ASSUCCESS);
}
