/* getc.c
*
* The Greenleaf Comm Library
*
* Copyright (C) 1985-1990 Greenleaf Software Inc.  All Rights Reserved.
*
*  int asigetc(port)
*  int port;            - Port 0..MAX_PORTS-1
*
* DESCRIPTION
*  this function "gets" a character from the communications port
*  using interrupt mode.
*
* SIDE EFFECTS
*  none.
*
* RETURNS
*
*       Value           Meaning
*       ------          -------
*       0 thru 255      Return value equals character received
*       ASINVPORT       Requested port is out of range
*       ASNOTSETUP      Requested port not setup with asifirst()
*       ASBUFREMPTY     Requested port's buffer is empty
*
* MODIFICATIONS
*
*  11-01-85     ""
*               Modified for release 2.0
*
*  23-FEB-1987  08:55:40.44
*       removed call to _aschkcnl(), replaced with in-line code for speed.
*/
#include <stdio.h>
#include "gf.h"
#include "asiports.h"

int GF_CONV asigetc(port)
int port;
{
    struct PORT_TABLE *p;

    if ( port < 0 || port >= MAX_PORT ) {
        _aserror = ASINVPORT ;
        return( ASINVPORT );
    }
    if ( as_chnl == NULL || ( p = as_chnl->tblport[port].ptb ) == NULL ) {
        _aserror = ASNOTSETUP;
        return( ASNOTSETUP );
    }
    _aserror= ASSUCCESS;
    if ( p->chst_bits.rxempty == 1 )
        return( ASBUFREMPTY );
    return( _asigetc( p ) );
}

