/* isrchk.c
*
* The Greenleaf Comm Library
*
* Copyright (C) 1985-1990 Greenleaf Software Inc.  All Rights Reserved.
*
*  int isrchk( port,chk )
*  int port;            - Port 0..MAX_PORT-1
*  int chk;             - One of three codes to check (0..2)
*
* DESCRIPTION
*  Checks for receiver check flag set.
*
* RETURNS
*  0 if flag is not set, 1 if flag is set or a negative value (listed
*  below) indicating an error condition.
*
*       Value           Meaning
*       ------          --------
*       ASINVPORT       Requested port is out of range
*       ASNOTSETUP      Requested port not setup with asifirst()
*       ASINVPAR        Invalid parameter
*
* SIDE EFFECTS
*  none
*
* MODIFICATIONS
*  11-09-85     ""
*               Modified for release 2.0
*/

#include <stdio.h>
#include "gf.h"
#include "asiports.h"

int GF_CONV isrchk(port,chk )
int port,chk;
{
        struct PORT_TABLE *p;

        if((p=_aschkcnl(port))==NULL)
                return(_aserror);
        if(chk<0 || chk>2)
                return(ASINVPAR);
        return((p->chkchr[chk]&0x4000)?TRUE:FALSE);

}

