/* wgetb.c
*
* The Greenleaf Comm Library
*
* Copyright (C) 1985-1990 Greenleaf Software Inc.  All Rights Reserved.
*
*  unsigned asiwgetb( port, buffer, length, stat)
*  int port;            - Port 0..MAX_PORT-1
*  char *buffer;        - Points to buffer that is to receive characters
*  unsigned length;     - Maximum number of characters that can be received
*  char *stat;          - Pointer to destination status buffer
*
* DESCRIPTION
*
*  Transfers characters from receive queue to user buffer.  Note that this
*  function doesn't really do any work.  All the work is done by calling
*  asiwgetb_timed, with a ticks parameter of 0.
*
* SIDE EFFECTS
*  none
*
* RETURNS
*  returns the number of characters SUCCESSFULLY transferred.  The global
*  variable _aserror can be examined to determine if an error was detected.
*  _aserror == 0 if no errors were detected.  If the receive queue becomes
*  empty before the entire user buffer is filled _aserror will be set to
*  ASBUFREMPTY.
*
*       Value           Meaning
*     -------          --------
*       ASSUCCESS       port initialized (no error)
*       ASINVPORT       Requested port is out of range
*       ASNOTSETUP      Requested port not setup with asifirst()
*       ASBUFREMPTY     Receive buffer went empty before length characters
*                       were transferred.
*       ASNOWIDERX      Wide Track receive not enabled for this channel.
*
* MODIFICATIONS
*
*/
#include <stdio.h>
#include "gf.h"
#include "asiports.h"

unsigned int GF_CONV asiwgetb( int port,
                       char *buffer,
                       unsigned int length,
                       char *stat )
{
    return( asiwgetb_timed( port, buffer, length, stat, 0 ) );
}

